#ifndef _H_F3B21339F062DEE00311AA2612771AA6_Twist2D32_DCPS_H_
#define _H_F3B21339F062DEE00311AA2612771AA6_Twist2D32_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Twist2D32_.h"


namespace nav_2d_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Twist2D32_TypeSupportInterface;

            typedef Twist2D32_TypeSupportInterface * Twist2D32_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Twist2D32_TypeSupportInterface> Twist2D32_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Twist2D32_TypeSupportInterface> Twist2D32_TypeSupportInterface_out;


            class Twist2D32_DataWriter;

            typedef Twist2D32_DataWriter * Twist2D32_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Twist2D32_DataWriter> Twist2D32_DataWriter_var;
            typedef DDS_DCPSInterface_out < Twist2D32_DataWriter> Twist2D32_DataWriter_out;


            class Twist2D32_DataReader;

            typedef Twist2D32_DataReader * Twist2D32_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Twist2D32_DataReader> Twist2D32_DataReader_var;
            typedef DDS_DCPSInterface_out < Twist2D32_DataReader> Twist2D32_DataReader_out;


            class Twist2D32_DataReaderView;

            typedef Twist2D32_DataReaderView * Twist2D32_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Twist2D32_DataReaderView> Twist2D32_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Twist2D32_DataReaderView> Twist2D32_DataReaderView_out;

            struct Twist2D32_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Twist2D32_, struct Twist2D32_Seq_uniq_> Twist2D32_Seq;
            typedef DDS_DCPSSequence_var < Twist2D32_Seq> Twist2D32_Seq_var;
            typedef DDS_DCPSSequence_out < Twist2D32_Seq> Twist2D32_Seq_out;

            class  Twist2D32_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Twist2D32_TypeSupportInterface_ptr _ptr_type;
                typedef Twist2D32_TypeSupportInterface_var _var_type;

                static Twist2D32_TypeSupportInterface_ptr _duplicate (Twist2D32_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Twist2D32_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Twist2D32_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Twist2D32_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Twist2D32_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Twist2D32_TypeSupportInterface () {};
                ~Twist2D32_TypeSupportInterface () {};
            private:
                Twist2D32_TypeSupportInterface (const Twist2D32_TypeSupportInterface &);
                Twist2D32_TypeSupportInterface & operator = (const Twist2D32_TypeSupportInterface &);
            };

            class  Twist2D32_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Twist2D32_DataWriter_ptr _ptr_type;
                typedef Twist2D32_DataWriter_var _var_type;

                static Twist2D32_DataWriter_ptr _duplicate (Twist2D32_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Twist2D32_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Twist2D32_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Twist2D32_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Twist2D32_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Twist2D32_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Twist2D32_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Twist2D32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Twist2D32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Twist2D32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Twist2D32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Twist2D32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Twist2D32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Twist2D32_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Twist2D32_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Twist2D32_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Twist2D32_& instance_data) = 0;

            protected:
                Twist2D32_DataWriter () {};
                ~Twist2D32_DataWriter () {};
            private:
                Twist2D32_DataWriter (const Twist2D32_DataWriter &);
                Twist2D32_DataWriter & operator = (const Twist2D32_DataWriter &);
            };

            class  Twist2D32_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Twist2D32_DataReader_ptr _ptr_type;
                typedef Twist2D32_DataReader_var _var_type;

                static Twist2D32_DataReader_ptr _duplicate (Twist2D32_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Twist2D32_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Twist2D32_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Twist2D32_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Twist2D32_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Twist2D32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Twist2D32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Twist2D32_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Twist2D32_& instance) = 0;

            protected:
                Twist2D32_DataReader () {};
                ~Twist2D32_DataReader () {};
            private:
                Twist2D32_DataReader (const Twist2D32_DataReader &);
                Twist2D32_DataReader & operator = (const Twist2D32_DataReader &);
            };

            class  Twist2D32_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Twist2D32_DataReaderView_ptr _ptr_type;
                typedef Twist2D32_DataReaderView_var _var_type;

                static Twist2D32_DataReaderView_ptr _duplicate (Twist2D32_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Twist2D32_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Twist2D32_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Twist2D32_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Twist2D32_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Twist2D32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Twist2D32_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Twist2D32_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Twist2D32_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Twist2D32_& instance) = 0;

            protected:
                Twist2D32_DataReaderView () {};
                ~Twist2D32_DataReaderView () {};
            private:
                Twist2D32_DataReaderView (const Twist2D32_DataReaderView &);
                Twist2D32_DataReaderView & operator = (const Twist2D32_DataReaderView &);
            };
        }

    }

}

#endif
